//
//  ViewController.swift
//  Calculator
//
//  Created by Sameh Fakhouri on 11/7/16.
//  Copyright © 2016 Sameh Fakhouri. All rights reserved.
//

import UIKit

class ViewController: UIViewController {
    
    private var brain = CalculatorBrain()

    @IBOutlet weak private var display: UILabel!

    private var userIsInTheMiddleOfTyping : Bool = false
 
    
    private var displayValue : Double {
        get {
            return Double(self.display.text!)!
        }
        
        set {
            display.text = String(newValue)
        }
    }
    
    
    @IBAction private func touchDigit(_ sender: UIButton) {
        let digit = sender.currentTitle!
        
        print("touched \(digit) digit")
        
        let textCurrentlyInDisplay = display!.text
        
        if (userIsInTheMiddleOfTyping) {
            display!.text = textCurrentlyInDisplay! + digit
        } else {
            display!.text = digit
        }
        userIsInTheMiddleOfTyping = true
    }

    
    @IBAction private func performOperation(_ sender: UIButton) {
        if (userIsInTheMiddleOfTyping) {
            brain.setOperand(operand: displayValue)
            userIsInTheMiddleOfTyping = false
        }
        
        if let mathematicalSymbol = sender.currentTitle {
            brain.performOperation(symbol: mathematicalSymbol)
        }
        
        displayValue = brain.result
    }
    

    
    
    
    
    
    
    
    
}

